main();


function main()
{
	//1. czynnoci wstpne
	if( PrzygotujModel() < 0 ) return;

	//straty bazowe
	var sb = ObliczStraty();
	cprintf("Straty bazowe: " + sb.toFixed(1) );

	var ar = new Array;

	
	//2. Wyczanie linii i wyznaczenie strat
	for( i=1; i<Data.N_Bra; i++)
	{
		var bra = BraArray.Get(i);
		
		//sprawdzenie, czy odpowiednia ga do wyczenia
		if(bra.St<=0 || bra.Mrkr<=0) continue;
		if(bra.typ!=1) continue;  //tylko linie

		var lin = LinArray.Get(bra.Indx);  //pominicie sprzgie
		if( lin.Typ!=1) continue;
      		
		//wyczenie gazi
		bra.St=-1;

		//rozpyw, 
	    if( CalcLF()!=1 ) 
		{
			TestConnection(0);  //test spjnoci
			if( CalcLF()!=1 ) 
			{
				cprintf("\R" + bra.Name + " (" 
				+ bra.BegName + "<-> " + bra.EndName
				+ ") Rozpyw rozbieny");
				continue;
			}
		}
    
		//dodanie wyniku do tablicy
		info = new Object();
		info.bra = bra.Name;
		info.beg = bra.BegName;
		info.end = bra.EndName;
		info.str = ObliczStraty();
		info.dst = info.str - sb;             //bezwzgldny przyrost strat
		info.wds = Math.abs(info.dst)/sb*100; //wzgldna zmiana wielkoci strat
		ar.push(info);
    
            
		//przywrcenie modelu wejciowego == zaczenie linii wyczanej
		ReadDataBIN("DaneBin.bin");
	}

  
	//3. posortowanie i wywietlenie wynikw
	ar.sort( CompareForSort );

	for(i=0;i<ar.length; i++)
		cprintf( ar[i].bra + "   (" + 
		         ar[i].beg + "<->  " + 
		         ar[i].end + ")   " + 
		         ar[i].str.toFixed(1) + "   " + 
		         ar[i].dst.toFixed(1) + "   " + 
		         ar[i].wds.toFixed(1) );
}

/////////////////////////////////////////////////////////////////
// Przygotowanie modelu
function PrzygotujModel()
{
	//wczytanie modelu
	ReadDataKDM("");

	//rozpyw bazowy
	if( CalcLF()!=1 ) { 
		cprintf("/RRozpyw rozbieny");
		return -1;
	}

	//Wybr obszaru - Polski
	try
	{
		for(i=1; i<Data.N_Zon; i++) ZonArray.Get(i).Selected=0;
		ZonArray.Find("Kraj").Selected=1;
		ZonArray.ApplySelection();
	}
	catch(e)
	{
		cprintf("Brak obszaru Kraj???");
		return -2;
	}

	//Zapisanie modelu do pliku bin
	SaveDataBIN("DaneBin.bin");

	cprintf(Data.GetVariant(0));

	return 1;
}


/////////////////////////////////////////////////////////////////
// Obliczenie strat w sieci przesyowej danego obszaru
function ObliczStraty()
{
	var dP = 0;

	for(var i=1; i<Data.N_Bra; i++)
	{
		var bra = BraArray.Get(i);

		if(bra.St<=0 || bra.Mrkr<=0) continue;  //W wybranym obszarze

		dP += bra.dP;

	}
	return dP;
} 
 

/////////////////////////////////////////////////////////////////
// Kryterium sortowania dla start - po bezwgldnej rnicy strat
function CompareForSort( p1, p2)
{
	if( p1.dst<p2.dst ) return 1;
	else return -1;
} 
 
 

